/* filehelper.c generated by valac 0.36.1, the Vala compiler
 * generated from filehelper.vala, do not modify */

/* filehelper.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Brosch Florian <flo.brosch@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>

#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean valadoc_copy_file (const gchar* src, const gchar* dest);
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest);
gboolean valadoc_remove_directory (const gchar* rpath);
gboolean valadoc_ends_with_dir_separator (const gchar* s);
gchar* valadoc_realpath (const gchar* name);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Makes a copy of the file src to dest. 
 *
 * @param src the file to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_file (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	FILE* fsrc;
	const gchar* _tmp0_;
	FILE* _tmp1_;
	FILE* _tmp2_;
	FILE* fdest;
	const gchar* _tmp3_;
	FILE* _tmp4_;
	FILE* _tmp5_;
#line 35 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (src != NULL, FALSE);
#line 35 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 36 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp0_ = src;
#line 36 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp1_ = g_fopen (_tmp0_, "rb");
#line 36 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	fsrc = _tmp1_;
#line 37 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp2_ = fsrc;
#line 37 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (_tmp2_ == NULL) {
#line 38 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 38 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_fclose0 (fsrc);
#line 38 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		return result;
#line 87 "filehelper.c"
	}
#line 41 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp3_ = dest;
#line 41 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp4_ = g_fopen (_tmp3_, "wb");
#line 41 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	fdest = _tmp4_;
#line 42 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp5_ = fdest;
#line 42 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (_tmp5_ == NULL) {
#line 43 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 43 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_fclose0 (fdest);
#line 43 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_fclose0 (fsrc);
#line 43 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		return result;
#line 107 "filehelper.c"
	}
	{
		gint c;
		FILE* _tmp6_;
		gint _tmp7_;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp6_ = fsrc;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp7_ = fgetc (_tmp6_);
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		c = _tmp7_;
#line 119 "filehelper.c"
		{
			gboolean _tmp8_;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp8_ = TRUE;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			while (TRUE) {
#line 126 "filehelper.c"
				FILE* _tmp11_;
				gboolean _tmp12_;
				FILE* _tmp13_;
				gint _tmp14_;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				if (!_tmp8_) {
#line 133 "filehelper.c"
					FILE* _tmp9_;
					gint _tmp10_;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp9_ = fsrc;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp10_ = fgetc (_tmp9_);
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					c = _tmp10_;
#line 142 "filehelper.c"
				}
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp8_ = FALSE;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp11_ = fsrc;
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp12_ = feof (_tmp11_);
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				if (!(!_tmp12_)) {
#line 46 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					break;
#line 154 "filehelper.c"
				}
#line 47 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp13_ = fdest;
#line 47 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp14_ = c;
#line 47 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				fputc ((gchar) _tmp14_, _tmp13_);
#line 162 "filehelper.c"
			}
		}
	}
#line 50 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	result = TRUE;
#line 50 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_fclose0 (fdest);
#line 50 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_fclose0 (fsrc);
#line 50 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	return result;
#line 174 "filehelper.c"
}


/**
 * Makes a copy of the directory src to dest. 
 *
 * @param src the directory to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 59 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (src != NULL, FALSE);
#line 59 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 191 "filehelper.c"
	{
		GDir* dir;
		const gchar* _tmp0_;
		GDir* _tmp1_;
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp0_ = src;
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp1_ = g_dir_open (_tmp0_, (guint) 0, &_inner_error_);
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		dir = _tmp1_;
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 204 "filehelper.c"
			gboolean _tmp2_ = FALSE;
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 208 "filehelper.c"
				goto __catch1_g_file_error;
			}
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			g_clear_error (&_inner_error_);
#line 61 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			return _tmp2_;
#line 217 "filehelper.c"
		}
		{
			gchar* file;
			const gchar* _tmp3_;
			gchar* _tmp4_;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp3_ = g_dir_read_name (dir);
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			file = _tmp4_;
#line 229 "filehelper.c"
			{
				gboolean _tmp5_;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp5_ = TRUE;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				while (TRUE) {
#line 236 "filehelper.c"
					const gchar* _tmp8_;
					gchar* src_file_path;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* dest_file_path;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					const gchar* _tmp15_;
					gboolean _tmp16_;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (!_tmp5_) {
#line 250 "filehelper.c"
						const gchar* _tmp6_;
						gchar* _tmp7_;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp6_ = g_dir_read_name (dir);
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp7_ = g_strdup (_tmp6_);
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_g_free0 (file);
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						file = _tmp7_;
#line 261 "filehelper.c"
					}
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp5_ = FALSE;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp8_ = file;
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (!(_tmp8_ != NULL)) {
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						break;
#line 271 "filehelper.c"
					}
#line 63 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp9_ = src;
#line 63 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp10_ = file;
#line 63 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp11_ = g_build_filename (_tmp9_, _tmp10_, NULL);
#line 63 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					src_file_path = _tmp11_;
#line 64 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp12_ = dest;
#line 64 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp13_ = file;
#line 64 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp14_ = g_build_filename (_tmp12_, _tmp13_, NULL);
#line 64 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					dest_file_path = _tmp14_;
#line 65 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp15_ = src_file_path;
#line 65 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp16_ = g_file_test (_tmp15_, G_FILE_TEST_IS_DIR);
#line 65 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (_tmp16_) {
#line 295 "filehelper.c"
						const gchar* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						gboolean _tmp20_;
#line 66 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp17_ = dest_file_path;
#line 66 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						g_mkdir (_tmp17_, 0755);
#line 67 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp18_ = src_file_path;
#line 67 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp19_ = dest_file_path;
#line 67 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp20_ = valadoc_copy_directory (_tmp18_, _tmp19_);
#line 67 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						if (!_tmp20_) {
#line 68 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 68 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (dest_file_path);
#line 68 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (src_file_path);
#line 68 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (file);
#line 68 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 68 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							return result;
#line 324 "filehelper.c"
						}
					} else {
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						gboolean _tmp23_;
#line 71 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp21_ = src_file_path;
#line 71 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp22_ = dest_file_path;
#line 71 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp23_ = valadoc_copy_file (_tmp21_, _tmp22_);
#line 71 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						if (!_tmp23_) {
#line 72 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 72 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (dest_file_path);
#line 72 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (src_file_path);
#line 72 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (file);
#line 72 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 72 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							return result;
#line 350 "filehelper.c"
						}
					}
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_g_free0 (dest_file_path);
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_g_free0 (src_file_path);
#line 357 "filehelper.c"
				}
			}
#line 62 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_g_free0 (file);
#line 362 "filehelper.c"
		}
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_dir_close0 (dir);
#line 366 "filehelper.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* err = NULL;
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		err = _inner_error_;
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_inner_error_ = NULL;
#line 78 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 78 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_error_free0 (err);
#line 78 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		return result;
#line 382 "filehelper.c"
	}
	__finally1:
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 387 "filehelper.c"
		gboolean _tmp24_ = FALSE;
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		g_clear_error (&_inner_error_);
#line 60 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		return _tmp24_;
#line 395 "filehelper.c"
	}
#line 80 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	result = TRUE;
#line 80 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	return result;
#line 401 "filehelper.c"
}


/**
 * A recursive directory delete function
 *
 * @param rpath the directory to remove
 */
gboolean valadoc_remove_directory (const gchar* rpath) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 88 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (rpath != NULL, FALSE);
#line 415 "filehelper.c"
	{
		GDir* dir;
		const gchar* _tmp0_;
		GDir* _tmp1_;
		GDir* _tmp3_;
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp0_ = rpath;
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp1_ = g_dir_open (_tmp0_, (guint) 0, &_inner_error_);
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		dir = _tmp1_;
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 429 "filehelper.c"
			gboolean _tmp2_ = FALSE;
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 433 "filehelper.c"
				goto __catch2_g_file_error;
			}
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			g_clear_error (&_inner_error_);
#line 90 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			return _tmp2_;
#line 442 "filehelper.c"
		}
#line 91 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp3_ = dir;
#line 91 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		if (_tmp3_ == NULL) {
#line 92 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			result = FALSE;
#line 92 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_g_dir_close0 (dir);
#line 92 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			return result;
#line 454 "filehelper.c"
		}
		{
			const gchar* entry;
			GDir* _tmp4_;
			const gchar* _tmp5_;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp4_ = dir;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp5_ = g_dir_read_name (_tmp4_);
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			entry = _tmp5_;
#line 466 "filehelper.c"
			{
				gboolean _tmp6_;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp6_ = TRUE;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				while (TRUE) {
#line 473 "filehelper.c"
					const gchar* _tmp9_;
					gchar* path;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gboolean is_dir;
					const gchar* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (!_tmp6_) {
#line 485 "filehelper.c"
						GDir* _tmp7_;
						const gchar* _tmp8_;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp7_ = dir;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp8_ = g_dir_read_name (_tmp7_);
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						entry = _tmp8_;
#line 494 "filehelper.c"
					}
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp6_ = FALSE;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp9_ = entry;
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (!(_tmp9_ != NULL)) {
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						break;
#line 504 "filehelper.c"
					}
#line 95 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp10_ = rpath;
#line 95 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp11_ = entry;
#line 95 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 95 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					path = _tmp12_;
#line 97 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp13_ = path;
#line 97 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp14_ = g_file_test (_tmp13_, G_FILE_TEST_IS_DIR);
#line 97 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					is_dir = _tmp14_;
#line 98 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp15_ = is_dir;
#line 98 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (_tmp15_ == TRUE) {
#line 524 "filehelper.c"
						gboolean tmp;
						const gchar* _tmp16_;
						gboolean _tmp17_;
						gboolean _tmp18_;
#line 99 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp16_ = path;
#line 99 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp17_ = valadoc_remove_directory (_tmp16_);
#line 99 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						tmp = _tmp17_;
#line 100 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp18_ = tmp;
#line 100 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						if (_tmp18_ == FALSE) {
#line 101 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 101 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (path);
#line 101 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 101 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							return result;
#line 547 "filehelper.c"
						}
					} else {
						gint tmp;
						const gchar* _tmp19_;
						gint _tmp20_;
						gint _tmp21_;
#line 104 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp19_ = path;
#line 104 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp20_ = g_unlink (_tmp19_);
#line 104 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						tmp = _tmp20_;
#line 105 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp21_ = tmp;
#line 105 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						if (_tmp21_ > 0) {
#line 106 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 106 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (path);
#line 106 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 106 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							return result;
#line 572 "filehelper.c"
						}
					}
#line 94 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_g_free0 (path);
#line 577 "filehelper.c"
				}
			}
		}
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_dir_close0 (dir);
#line 583 "filehelper.c"
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError* err = NULL;
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		err = _inner_error_;
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_inner_error_ = NULL;
#line 111 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 111 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_error_free0 (err);
#line 111 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		return result;
#line 599 "filehelper.c"
	}
	__finally2:
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 604 "filehelper.c"
		gboolean _tmp22_ = FALSE;
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		g_clear_error (&_inner_error_);
#line 89 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		return _tmp22_;
#line 612 "filehelper.c"
	}
#line 114 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	result = TRUE;
#line 114 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	return result;
#line 618 "filehelper.c"
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_;
#line 1140 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1141 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1141 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1141 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1141 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 636 "filehelper.c"
}


inline gboolean valadoc_ends_with_dir_separator (const gchar* s) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gunichar _tmp4_;
	gboolean _tmp5_;
#line 118 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp0_ = s;
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp1_ = s;
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp2_ = strlen (_tmp1_);
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp3_ = _tmp2_;
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp4_ = string_get_char (_tmp0_, (glong) (_tmp3_ - 1));
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp5_ = G_IS_DIR_SEPARATOR (_tmp4_);
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	result = _tmp5_;
#line 120 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	return result;
#line 666 "filehelper.c"
}


/**
 * Returns canonicalized absolute pathname
 *
 * @param name the path being checked
 * @return a canonicalized absolute pathname
 */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1322 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1323 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 695 "filehelper.c"
		glong _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1324 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 703 "filehelper.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1326 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 715 "filehelper.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
#line 1333 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 739 "filehelper.c"
		glong _tmp2_;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 745 "filehelper.c"
	} else {
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 749 "filehelper.c"
	}
#line 1335 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 753 "filehelper.c"
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1337 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 765 "filehelper.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1339 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 775 "filehelper.c"
	}
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1342 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 781 "filehelper.c"
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1343 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1344 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 795 "filehelper.c"
	} else {
		glong _tmp12_;
		glong _tmp13_;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1346 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 805 "filehelper.c"
	}
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1348 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 811 "filehelper.c"
		glong _tmp15_;
		glong _tmp16_;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1349 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 820 "filehelper.c"
	}
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1351 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1352 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 840 "filehelper.c"
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
#line 1078 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = separator;
#line 1078 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp0_ == NULL) {
#line 1079 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		separator = "";
#line 857 "filehelper.c"
	}
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3_ = str_array;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp3__length1 = str_array_length1;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 867 "filehelper.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = str_array;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4__length1 = str_array_length1;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp4__length1 > 0;
#line 877 "filehelper.c"
	}
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp2_) {
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 883 "filehelper.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = str_array;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6__length1 = str_array_length1;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		if (_tmp6__length1 == -1) {
#line 894 "filehelper.c"
			gchar** _tmp7_;
			gint _tmp7__length1;
			const gchar* _tmp8_;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp7_ = str_array;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp7__length1 = str_array_length1;
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp8_ = _tmp7_[0];
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp5_ = _tmp8_ != NULL;
#line 906 "filehelper.c"
		} else {
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 910 "filehelper.c"
		}
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp1_ = _tmp5_;
#line 914 "filehelper.c"
	}
#line 1081 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 918 "filehelper.c"
		gint i = 0;
		gsize len;
		gint _tmp31_;
		gint _tmp33_;
		gint _tmp34_;
		gsize _tmp35_;
		const gchar* _tmp36_;
		gint _tmp37_;
		gint _tmp38_;
		gint _tmp39_;
		const gchar* res;
		gsize _tmp40_;
		void* _tmp41_;
		void* ptr;
		const gchar* _tmp42_;
		gchar** _tmp43_;
		gint _tmp43__length1;
		const gchar* _tmp44_;
		void* _tmp45_;
		const gchar* _tmp62_;
#line 1083 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		len = (gsize) 1;
#line 941 "filehelper.c"
		{
			gboolean _tmp9_;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			i = 0;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp9_ = TRUE;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 950 "filehelper.c"
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_;
				gint _tmp13__length1;
				gint _tmp21_ = 0;
				gchar** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_;
				const gchar* _tmp24_;
				gsize _tmp30_;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (!_tmp9_) {
#line 963 "filehelper.c"
					gint _tmp10_;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp10_ = i;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					i = _tmp10_ + 1;
#line 969 "filehelper.c"
				}
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp9_ = FALSE;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp13_ = str_array;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp13__length1 = str_array_length1;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (_tmp13__length1 != -1) {
#line 979 "filehelper.c"
					gint _tmp14_;
					gchar** _tmp15_;
					gint _tmp15__length1;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp14_ = i;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp15_ = str_array;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp15__length1 = str_array_length1;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp12_ = _tmp14_ < _tmp15__length1;
#line 991 "filehelper.c"
				} else {
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp12_ = FALSE;
#line 995 "filehelper.c"
				}
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (_tmp12_) {
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp11_ = TRUE;
#line 1001 "filehelper.c"
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_;
					gint _tmp17__length1;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp17_ = str_array;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp17__length1 = str_array_length1;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					if (_tmp17__length1 == -1) {
#line 1012 "filehelper.c"
						gchar** _tmp18_;
						gint _tmp18__length1;
						gint _tmp19_;
						const gchar* _tmp20_;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
						_tmp18_ = str_array;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
						_tmp18__length1 = str_array_length1;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
						_tmp19_ = i;
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
						_tmp20_ = _tmp18_[_tmp19_];
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
						_tmp16_ = _tmp20_ != NULL;
#line 1027 "filehelper.c"
					} else {
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
						_tmp16_ = FALSE;
#line 1031 "filehelper.c"
					}
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp11_ = _tmp16_;
#line 1035 "filehelper.c"
				}
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (!_tmp11_) {
#line 1084 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					break;
#line 1041 "filehelper.c"
				}
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp22_ = str_array;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp22__length1 = str_array_length1;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp23_ = i;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp24_ = _tmp22_[_tmp23_];
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (_tmp24_ != NULL) {
#line 1053 "filehelper.c"
					gchar** _tmp25_;
					gint _tmp25__length1;
					gint _tmp26_;
					const gchar* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp25_ = str_array;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp25__length1 = str_array_length1;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp26_ = i;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp27_ = _tmp25_[_tmp26_];
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp28_ = strlen ((const gchar*) _tmp27_);
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp29_ = _tmp28_;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp21_ = _tmp29_;
#line 1074 "filehelper.c"
				} else {
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp21_ = 0;
#line 1078 "filehelper.c"
				}
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp30_ = len;
#line 1085 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				len = _tmp30_ + _tmp21_;
#line 1084 "filehelper.c"
			}
		}
#line 1087 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp31_ = i;
#line 1087 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		if (_tmp31_ == 0) {
#line 1091 "filehelper.c"
			gchar* _tmp32_;
#line 1088 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp32_ = g_strdup ("");
#line 1088 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			result = _tmp32_;
#line 1088 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			return result;
#line 1099 "filehelper.c"
		}
#line 1090 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp33_ = i;
#line 1090 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		str_array_length1 = _tmp33_;
#line 1090 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp34_ = str_array_length1;
#line 1091 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp35_ = len;
#line 1091 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp36_ = separator;
#line 1091 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp37_ = strlen ((const gchar*) _tmp36_);
#line 1091 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp38_ = _tmp37_;
#line 1091 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp39_ = i;
#line 1091 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
#line 1093 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp40_ = len;
#line 1093 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp41_ = g_malloc (_tmp40_);
#line 1093 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		res = _tmp41_;
#line 1094 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp42_ = res;
#line 1094 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp43_ = str_array;
#line 1094 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp43__length1 = str_array_length1;
#line 1094 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp44_ = _tmp43_[0];
#line 1094 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
#line 1094 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		ptr = _tmp45_;
#line 1137 "filehelper.c"
		{
			gboolean _tmp46_;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			i = 1;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			_tmp46_ = TRUE;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 1146 "filehelper.c"
				gint _tmp48_;
				gchar** _tmp49_;
				gint _tmp49__length1;
				void* _tmp50_;
				const gchar* _tmp51_;
				void* _tmp52_;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				const gchar* _tmp56_;
				void* _tmp60_;
				void* _tmp61_;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (!_tmp46_) {
#line 1162 "filehelper.c"
					gint _tmp47_;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp47_ = i;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					i = _tmp47_ + 1;
#line 1168 "filehelper.c"
				}
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp46_ = FALSE;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp48_ = i;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp49_ = str_array;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp49__length1 = str_array_length1;
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (!(_tmp48_ < _tmp49__length1)) {
#line 1095 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					break;
#line 1182 "filehelper.c"
				}
#line 1096 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp50_ = ptr;
#line 1096 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp51_ = separator;
#line 1096 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
#line 1096 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				ptr = _tmp52_;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp54_ = str_array;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp54__length1 = str_array_length1;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp55_ = i;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp56_ = _tmp54_[_tmp55_];
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				if (_tmp56_ != NULL) {
#line 1202 "filehelper.c"
					gchar** _tmp57_;
					gint _tmp57__length1;
					gint _tmp58_;
					const gchar* _tmp59_;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp57_ = str_array;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp57__length1 = str_array_length1;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp58_ = i;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp59_ = _tmp57_[_tmp58_];
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp53_ = (const gchar*) _tmp59_;
#line 1217 "filehelper.c"
				} else {
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
					_tmp53_ = "";
#line 1221 "filehelper.c"
				}
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp60_ = ptr;
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
#line 1097 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
				ptr = _tmp61_;
#line 1229 "filehelper.c"
			}
		}
#line 1100 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp62_ = res;
#line 1100 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		res = NULL;
#line 1100 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = (gchar*) _tmp62_;
#line 1100 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 1240 "filehelper.c"
	} else {
		gchar* _tmp63_;
#line 1102 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp63_ = g_strdup ("");
#line 1102 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		result = _tmp63_;
#line 1102 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		return result;
#line 1249 "filehelper.c"
	}
}


gchar* valadoc_realpath (const gchar* name) {
	gchar* result = NULL;
	gchar* rpath = NULL;
	const gchar* start = NULL;
	const gchar* end = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	glong root_len;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gboolean _tmp66_ = FALSE;
	const gchar* _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	glong _tmp70_;
#line 129 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 139 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp0_ = name;
#line 139 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp1_ = g_path_is_absolute (_tmp0_);
#line 139 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (!_tmp1_) {
#line 1278 "filehelper.c"
		gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 141 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp2_ = g_get_current_dir ();
#line 141 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 141 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp2_;
#line 143 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp3_ = name;
#line 143 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		end = _tmp3_;
#line 143 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp4_ = end;
#line 143 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		start = _tmp4_;
#line 1296 "filehelper.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 146 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp5_ = name;
#line 146 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp6_ = g_path_skip_root (_tmp5_);
#line 146 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		end = _tmp6_;
#line 146 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp7_ = end;
#line 146 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		start = _tmp7_;
#line 149 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp8_ = name;
#line 149 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp9_ = start;
#line 149 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp10_ = name;
#line 149 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp11_ = string_substring (_tmp8_, (glong) 0, (glong) ((gint) (((gchar*) _tmp9_) - ((gchar*) _tmp10_))));
#line 149 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 149 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp11_;
#line 1327 "filehelper.c"
	}
#line 152 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp12_ = rpath;
#line 152 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp13_ = g_path_skip_root (_tmp12_);
#line 152 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp14_ = rpath;
#line 152 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	root_len = (glong) (((gchar*) _tmp13_) - ((gchar*) _tmp14_));
#line 1337 "filehelper.c"
	{
		gboolean _tmp15_;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp15_ = TRUE;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		while (TRUE) {
#line 1344 "filehelper.c"
			const gchar* _tmp17_;
			gunichar _tmp18_;
			glong len;
			glong _tmp35_;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			if (!_tmp15_) {
#line 1351 "filehelper.c"
				const gchar* _tmp16_;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp16_ = end;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				start = _tmp16_;
#line 1357 "filehelper.c"
			}
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp15_ = FALSE;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp17_ = start;
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp18_ = string_get_char (_tmp17_, (glong) 0);
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			if (!(_tmp18_ != ((gunichar) 0))) {
#line 154 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				break;
#line 1369 "filehelper.c"
			}
#line 156 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			while (TRUE) {
#line 1373 "filehelper.c"
				const gchar* _tmp19_;
				gunichar _tmp20_;
				gboolean _tmp21_;
				const gchar* _tmp22_;
				const gchar* _tmp23_;
#line 156 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp19_ = start;
#line 156 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp20_ = string_get_char (_tmp19_, (glong) 0);
#line 156 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp21_ = G_IS_DIR_SEPARATOR (_tmp20_);
#line 156 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				if (!_tmp21_) {
#line 156 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					break;
#line 1389 "filehelper.c"
				}
#line 157 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp22_ = start;
#line 157 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp23_ = g_utf8_next_char (_tmp22_);
#line 157 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				start = _tmp23_;
#line 1397 "filehelper.c"
			}
#line 161 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			len = (glong) 0;
#line 1401 "filehelper.c"
			{
				const gchar* _tmp24_;
				gboolean _tmp25_;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp24_ = start;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				end = _tmp24_;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp25_ = TRUE;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				while (TRUE) {
#line 1413 "filehelper.c"
					gboolean _tmp28_ = FALSE;
					const gchar* _tmp29_;
					gunichar _tmp30_;
					glong _tmp34_;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (!_tmp25_) {
#line 1420 "filehelper.c"
						const gchar* _tmp26_;
						const gchar* _tmp27_;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp26_ = end;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp27_ = g_utf8_next_char (_tmp26_);
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						end = _tmp27_;
#line 1429 "filehelper.c"
					}
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp25_ = FALSE;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp29_ = end;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp30_ = string_get_char (_tmp29_, (glong) 0);
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (_tmp30_ != ((gunichar) 0)) {
#line 1439 "filehelper.c"
						const gchar* _tmp31_;
						gunichar _tmp32_;
						gboolean _tmp33_;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp31_ = end;
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp32_ = string_get_char (_tmp31_, (glong) 0);
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp33_ = G_IS_DIR_SEPARATOR (_tmp32_);
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp28_ = !_tmp33_;
#line 1451 "filehelper.c"
					} else {
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp28_ = FALSE;
#line 1455 "filehelper.c"
					}
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (!_tmp28_) {
#line 162 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						break;
#line 1461 "filehelper.c"
					}
#line 163 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp34_ = len;
#line 163 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					len = _tmp34_ + 1;
#line 1467 "filehelper.c"
				}
			}
#line 166 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			_tmp35_ = len;
#line 166 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
			if (_tmp35_ == ((glong) 0)) {
#line 167 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				break;
#line 1476 "filehelper.c"
			} else {
				gboolean _tmp36_ = FALSE;
				glong _tmp37_;
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				_tmp37_ = len;
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				if (_tmp37_ == ((glong) 1)) {
#line 1484 "filehelper.c"
					const gchar* _tmp38_;
					gunichar _tmp39_;
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp38_ = start;
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp39_ = string_get_char (_tmp38_, (glong) 0);
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp36_ = _tmp39_ == ((gunichar) '.');
#line 1493 "filehelper.c"
				} else {
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp36_ = FALSE;
#line 1497 "filehelper.c"
				}
#line 168 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
				if (_tmp36_) {
#line 1501 "filehelper.c"
				} else {
					gboolean _tmp40_ = FALSE;
					glong _tmp41_;
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					_tmp41_ = len;
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (_tmp41_ == ((glong) 2)) {
#line 1509 "filehelper.c"
						const gchar* _tmp42_;
						gboolean _tmp43_;
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp42_ = start;
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp43_ = g_str_has_prefix (_tmp42_, "..");
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp40_ = _tmp43_;
#line 1518 "filehelper.c"
					} else {
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp40_ = FALSE;
#line 1522 "filehelper.c"
					}
#line 170 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
					if (_tmp40_) {
#line 1526 "filehelper.c"
						const gchar* _tmp44_;
						gint _tmp45_;
						gint _tmp46_;
						glong _tmp47_;
#line 172 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp44_ = rpath;
#line 172 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp45_ = strlen (_tmp44_);
#line 172 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp46_ = _tmp45_;
#line 172 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp47_ = root_len;
#line 172 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						if (((glong) _tmp46_) > _tmp47_) {
#line 1541 "filehelper.c"
							{
								gboolean _tmp48_;
#line 173 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
								_tmp48_ = TRUE;
#line 173 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
								while (TRUE) {
#line 1548 "filehelper.c"
									const gchar* _tmp51_;
									const gchar* _tmp52_;
									gint _tmp53_;
									gint _tmp54_;
									gchar* _tmp55_;
#line 173 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									if (!_tmp48_) {
#line 1556 "filehelper.c"
										const gchar* _tmp49_;
										gboolean _tmp50_;
#line 175 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
										_tmp49_ = rpath;
#line 175 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
										_tmp50_ = valadoc_ends_with_dir_separator (_tmp49_);
#line 175 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
										if (!(!_tmp50_)) {
#line 175 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
											break;
#line 1567 "filehelper.c"
										}
									}
#line 173 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_tmp48_ = FALSE;
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_tmp51_ = rpath;
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_tmp52_ = rpath;
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_tmp53_ = strlen (_tmp52_);
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_tmp54_ = _tmp53_;
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_tmp55_ = string_substring (_tmp51_, (glong) 0, (glong) (_tmp54_ - 1));
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									_g_free0 (rpath);
#line 174 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
									rpath = _tmp55_;
#line 1586 "filehelper.c"
								}
							}
						}
					} else {
						const gchar* _tmp56_;
						gboolean _tmp57_;
						const gchar* _tmp60_;
						const gchar* _tmp61_;
						glong _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
						gchar* _tmp65_;
#line 178 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp56_ = rpath;
#line 178 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp57_ = valadoc_ends_with_dir_separator (_tmp56_);
#line 178 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						if (!_tmp57_) {
#line 1605 "filehelper.c"
							const gchar* _tmp58_;
							gchar* _tmp59_;
#line 179 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_tmp58_ = rpath;
#line 179 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_tmp59_ = g_strconcat (_tmp58_, G_DIR_SEPARATOR_S, NULL);
#line 179 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							_g_free0 (rpath);
#line 179 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
							rpath = _tmp59_;
#line 1616 "filehelper.c"
						}
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp60_ = rpath;
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp61_ = start;
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp62_ = len;
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp63_ = string_substring (_tmp61_, (glong) 0, _tmp62_);
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp64_ = _tmp63_;
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_g_free0 (rpath);
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						rpath = _tmp65_;
#line 182 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
						_g_free0 (_tmp64_);
#line 1636 "filehelper.c"
					}
				}
			}
		}
	}
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp67_ = rpath;
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp68_ = strlen (_tmp67_);
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp69_ = _tmp68_;
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	_tmp70_ = root_len;
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (((glong) _tmp69_) > _tmp70_) {
#line 1652 "filehelper.c"
		const gchar* _tmp71_;
		gboolean _tmp72_;
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp71_ = rpath;
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp72_ = valadoc_ends_with_dir_separator (_tmp71_);
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp66_ = _tmp72_;
#line 1661 "filehelper.c"
	} else {
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp66_ = FALSE;
#line 1665 "filehelper.c"
	}
#line 186 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (_tmp66_) {
#line 1669 "filehelper.c"
		const gchar* _tmp73_;
		const gchar* _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gchar* _tmp77_;
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp73_ = rpath;
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp74_ = rpath;
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp75_ = strlen (_tmp74_);
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp76_ = _tmp75_;
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp77_ = string_substring (_tmp73_, (glong) 0, (glong) (_tmp76_ - 1));
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 187 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp77_;
#line 1689 "filehelper.c"
	}
#line 190 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	if (G_DIR_SEPARATOR != '/') {
#line 1693 "filehelper.c"
		gchar** components;
		const gchar* _tmp78_;
		gchar** _tmp79_;
		gchar** _tmp80_;
		gint components_length1;
		gint _components_size_;
		gchar** _tmp81_;
		gint _tmp81__length1;
		gchar* _tmp82_;
#line 193 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp78_ = rpath;
#line 193 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp80_ = _tmp79_ = g_strsplit (_tmp78_, "\\", 0);
#line 193 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		components = _tmp80_;
#line 193 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		components_length1 = _vala_array_length (_tmp79_);
#line 193 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_components_size_ = components_length1;
#line 194 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp81_ = components;
#line 194 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp81__length1 = components_length1;
#line 194 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_tmp82_ = _vala_g_strjoinv ("/", _tmp81_, _tmp81__length1);
#line 194 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 194 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp82_;
#line 190 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
		components = (_vala_array_free (components, components_length1, (GDestroyNotify) g_free), NULL);
#line 1725 "filehelper.c"
	}
#line 197 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	result = rpath;
#line 197 "/tmp/B.6lEqkR/BUILD/valadoc-0.36.0/src/libvaladoc/filehelper.vala"
	return result;
#line 1731 "filehelper.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



